"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InlineAnimation = function (_Component) {
    _inherits(InlineAnimation, _Component);

    function InlineAnimation(props) {
        _classCallCheck(this, InlineAnimation);

        var _this = _possibleConstructorReturn(this, (InlineAnimation.__proto__ || Object.getPrototypeOf(InlineAnimation)).call(this, props));

        _this.state = {
            style: _this.props.style,
            stage: 0,
            trigger: 0,
            steps: parseInt(_this.props.steps) || 20,
            timer: parseInt(_this.props.timer) || 10,
            count: 0,
            deg: parseInt(_this.props.deg) || 0,
            top: parseFloat(_this.props.style.top.replace("px", "")) || 0,
            left: parseFloat(_this.props.style.left.replace("px", "")) || 0,
            width: parseFloat(_this.props.style.width.replace("px", "")) || null,
            height: parseFloat(_this.props.style.height.replace("px", "")) || null,
            opacity: parseFloat(_this.props.style.opacity) || 1
        };
        return _this;
    }

    _createClass(InlineAnimation, [{
        key: "componentDidUpdate",
        value: function componentDidUpdate() {
            if (this.state.stage <= this.state.steps + 1 && this.state.trigger < this.state.stage) {
                switch (this.props.action) {
                    case "rotate":
                        setTimeout(this.rotate.bind(this), this.state.timer);
                        break;
                    case "vertical":
                        setTimeout(this.vertical.bind(this), this.state.timer);
                        break;
                    case "horizontal":
                        setTimeout(this.horizontal.bind(this), this.state.timer);
                        break;
                    case "fade":
                        setTimeout(this.fade.bind(this), this.state.timer);
                        break;
                    case "scale":
                        setTimeout(this.scale.bind(this), this.state.timer);
                        break;
                    case "move":
                        setTimeout(this.move.bind(this), this.state.timer);
                        break;
                }
            }
        }
    }, {
        key: "trigger",
        value: function trigger() {
            this.setState({ stage: 1, trigger: 0 });
        }
    }, {
        key: "rotate",
        value: function rotate() {
            var style = this.state.style;
            var stage = this.state.stage + 1;
            var progress = void 0;
            if (this.state.stage > 0 && this.state.stage < this.state.steps) {
                switch (this.props.direction) {
                    case "left":
                        progress = -(parseFloat(this.props.destiny) / parseInt(this.state.steps)) * this.state.stage + this.state.deg;
                        break;
                    case "right":
                        progress = parseFloat(this.props.destiny) / parseInt(this.state.steps) * this.state.stage + this.state.deg;
                        break;
                }
                style.transform = "rotate(" + progress + "deg)";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else if (this.state.stage === this.state.steps) {
                switch (this.props.direction) {
                    case "left":
                        progress = -parseInt(this.props.destiny) + this.state.deg;
                        break;
                    case "right":
                        progress = parseInt(this.props.destiny) + this.state.deg;
                        break;
                }
                style.transform = "rotate(" + progress + "deg)";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else {
                var deg = void 0;
                switch (this.props.direction) {
                    case "left":
                        deg = this.state.deg - parseInt(this.props.destiny);
                        break;
                    case "right":
                        deg = this.state.deg + parseInt(this.props.destiny);
                        break;
                }
                var count = this.state.count + 1;
                this.setState({ deg: deg, stage: stage, count: count, trigger: stage - 1 });
            }
        }
    }, {
        key: "vertical",
        value: function vertical() {
            var style = this.state.style;
            var stage = this.state.stage + 1;
            var progress = void 0;
            if (this.state.stage > 0 && this.state.stage < this.state.steps) {
                switch (this.props.direction) {
                    case "top":
                        progress = -(parseFloat(this.props.destiny) / parseInt(this.state.steps)) * this.state.stage + this.state.top;
                        break;
                    case "bottom":
                        progress = parseFloat(this.props.destiny) / parseInt(this.state.steps) * this.state.stage + this.state.top;
                        break;
                }
                style.top = progress + "px";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else if (this.state.stage === this.state.steps) {
                switch (this.props.direction) {
                    case "top":
                        progress = -parseInt(this.props.destiny) + this.state.top;
                        break;
                    case "bottom":
                        progress = parseInt(this.props.destiny) + this.state.top;
                        break;
                }
                style.top = progress + "px";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else {
                var top = void 0;
                switch (this.props.direction) {
                    case "top":
                        top = this.state.top - parseInt(this.props.destiny);
                        break;
                    case "bottom":
                        top = this.state.top + parseInt(this.props.destiny);
                        break;
                }
                var count = this.state.count + 1;
                this.setState({ top: top, stage: stage, count: count, trigger: stage - 1 });
            }
        }
    }, {
        key: "horizontal",
        value: function horizontal() {
            var style = this.state.style;
            var stage = this.state.stage + 1;
            var progress = void 0;
            if (this.state.stage > 0 && this.state.stage < this.state.steps) {
                switch (this.props.direction) {
                    case "left":
                        progress = -(parseFloat(this.props.destiny) / parseInt(this.state.steps)) * this.state.stage + this.state.left;
                        break;
                    case "right":
                        progress = parseFloat(this.props.destiny) / parseInt(this.state.steps) * this.state.stage + this.state.left;
                        break;
                }
                style.left = progress + "px";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else if (this.state.stage === this.state.steps) {
                switch (this.props.direction) {
                    case "left":
                        progress = -parseInt(this.props.destiny) + this.state.left;
                        break;
                    case "right":
                        progress = parseInt(this.props.destiny) + this.state.left;
                        break;
                }
                style.left = progress + "px";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else {
                var left = void 0;
                switch (this.props.direction) {
                    case "left":
                        left = this.state.left - parseInt(this.props.destiny);
                        break;
                    case "right":
                        left = this.state.left + parseInt(this.props.destiny);
                        break;
                }
                var count = this.state.count + 1;
                this.setState({ left: left, stage: stage, count: count, trigger: stage - 1 });
            }
        }
    }, {
        key: "fade",
        value: function fade() {
            var style = this.state.style;
            var stage = this.state.stage + 1;
            var progress = void 0;
            if (this.state.stage > 0 && this.state.stage < this.state.steps) {
                switch (this.props.direction) {
                    case "out":
                        progress = -(parseFloat(this.props.destiny) / parseInt(this.state.steps)) * this.state.stage + this.state.opacity;
                        break;
                    case "in":
                        progress = parseFloat(this.props.destiny) / parseInt(this.state.steps) * this.state.stage + this.state.opacity;
                        break;
                }
                if (style.opacity >= 0 && style.opacity <= 1) {
                    style.opacity = progress;
                }
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else if (this.state.stage === this.state.steps) {
                switch (this.props.direction) {
                    case "out":
                        progress = -parseInt(this.props.destiny) + this.state.opacity;
                        break;
                    case "in":
                        progress = parseInt(this.props.destiny) + this.state.opacity;
                        break;
                }
                if (style.opacity >= 0 && style.opacity <= 1) {
                    style.opacity = progress;
                } else if (style.opacity < 0) {
                    style.opacity = 0;
                } else if (style.opacity > 1) {
                    style.opacity = 1;
                }
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else {
                var opacity = void 0;
                switch (this.props.direction) {
                    case "out":
                        opacity = this.state.opacity - parseInt(this.props.destiny);
                        if (opacity < 0) {
                            opacity = 0;
                        } else if (opacity > 1) {
                            opacity = 1;
                        }
                        break;
                    case "in":
                        opacity = this.state.opacity + parseInt(this.props.destiny);
                        if (opacity < 0) {
                            opacity = 0;
                        } else if (opacity > 1) {
                            opacity = 1;
                        }
                        break;
                }
                var count = this.state.count + 1;
                this.setState({ opacity: opacity, stage: stage, count: count, trigger: stage - 1 });
            }
        }
    }, {
        key: "scale",
        value: function scale() {
            var style = this.state.style;
            var stage = this.state.stage + 1;
            var left = void 0,
                top = void 0,
                width = void 0,
                height = void 0;
            if (this.state.stage > 0 && this.state.stage < this.state.steps) {
                switch (this.props.direction) {
                    case "up":
                        left = -(parseFloat(this.props.destiny) * this.state.width / 2 / parseInt(this.state.steps)) * this.state.stage + this.state.left;
                        top = -(parseFloat(this.props.destiny) * this.state.height / 2 / parseInt(this.state.steps)) * this.state.stage + this.state.top;
                        width = parseFloat(this.props.destiny) * this.state.width / parseInt(this.state.steps) * this.state.stage + this.state.width;
                        height = parseFloat(this.props.destiny) * this.state.height / parseInt(this.state.steps) * this.state.stage + this.state.height;
                        break;
                    case "down":
                        left = parseFloat(this.props.destiny) * this.state.width / 2 / parseInt(this.state.steps) * this.state.stage + this.state.left;
                        top = parseFloat(this.props.destiny) * this.state.height / 2 / parseInt(this.state.steps) * this.state.stage + this.state.top;
                        width = -(parseFloat(this.props.destiny) * this.state.width / parseInt(this.state.steps)) * this.state.stage + this.state.width;
                        height = -(parseFloat(this.props.destiny) * this.state.height / parseInt(this.state.steps)) * this.state.stage + this.state.height;
                        break;
                }
                style.left = left + "px";
                style.top = top + "px";
                style.width = width + "px";
                style.height = height + "px";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else if (this.state.stage === this.state.steps) {
                switch (this.props.direction) {
                    case "up":
                        left = -(parseFloat(this.props.destiny) * this.state.width / 2) + this.state.left;
                        top = -(parseFloat(this.props.destiny) * this.state.height / 2) + this.state.top;
                        width = parseFloat(this.props.destiny) * this.state.width + this.state.width;
                        height = parseFloat(this.props.destiny) * this.state.height + this.state.height;
                        break;
                    case "down":
                        left = parseFloat(this.props.destiny) * this.state.width / 2 + this.state.left;
                        top = parseFloat(this.props.destiny) * this.state.height / 2 + this.state.top;
                        width = -parseFloat(this.props.destiny) * this.state.width + this.state.width;
                        height = -parseFloat(this.props.destiny) * this.state.height + this.state.height;
                        break;
                }
                style.left = left + "px";
                style.top = top + "px";
                style.width = width + "px";
                style.height = height + "px";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else {
                switch (this.props.direction) {
                    case "up":
                        left = -(parseFloat(this.props.destiny) * this.state.width / 2) + this.state.left;
                        top = -(parseFloat(this.props.destiny) * this.state.height / 2) + this.state.top;
                        width = parseFloat(this.props.destiny) * this.state.width + this.state.width;
                        height = parseFloat(this.props.destiny) * this.state.height + this.state.height;
                        break;
                    case "down":
                        left = parseFloat(this.props.destiny) * this.state.width / 2 + this.state.left;
                        top = parseFloat(this.props.destiny) * this.state.height / 2 + this.state.top;
                        width = -parseFloat(this.props.destiny) * this.state.width + this.state.width;
                        height = -parseFloat(this.props.destiny) * this.state.height + this.state.height;
                        break;
                }
                var count = this.state.count + 1;
                this.setState({ left: left, top: top, height: height, width: width, stage: stage, count: count, trigger: stage - 1 });
            }
        }
    }, {
        key: "move",
        value: function move() {
            var style = this.state.style;
            var stage = this.state.stage + 1;
            var left = void 0,
                top = void 0;
            if (this.state.stage > 0 && this.state.stage < this.state.steps) {
                switch (this.props.direction) {
                    case "center":
                        left = -((this.state.left - this.props.destiny[0] + this.state.width / 2) / parseInt(this.state.steps)) * this.state.stage + this.state.left;
                        top = -((this.state.top - this.props.destiny[1] + this.state.height / 2) / parseInt(this.state.steps)) * this.state.stage + this.state.top;
                        break;
                }
                style.left = left + "px";
                style.top = top + "px";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else if (this.state.stage === this.state.steps) {
                switch (this.props.direction) {
                    case "center":
                        left = this.props.destiny[0] - this.state.width / 2;
                        top = this.props.destiny[1] - this.state.height / 2;
                        break;
                }
                style.left = left + "px";
                style.top = top + "px";
                this.setState({ style: style, stage: stage, trigger: stage - 1 });
            } else {
                switch (this.props.direction) {
                    case "center":
                        left = this.props.destiny[0] - this.state.width / 2;
                        top = this.props.destiny[1] - this.state.height / 2;
                        break;
                }
                var count = this.state.count + 1;
                this.setState({ left: left, top: top, stage: stage, count: count, trigger: stage - 1 });
            }
        }
    }, {
        key: "render",
        value: function render() {
            var newStyle = JSON.parse(JSON.stringify(this.state.style));
            var container = void 0;
            if (this.props.restrict && this.props.restrict <= this.state.count) {
                container = _react2.default.cloneElement(this.props.component, { style: newStyle, animation: function animation() {
                        void 0;
                    } });
            } else {
                container = _react2.default.cloneElement(this.props.component, { style: newStyle, animation: this.trigger.bind(this) });
            }
            return container;
        }
    }]);

    return InlineAnimation;
}(_react.Component);

exports.default = InlineAnimation;